// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/async/lib/cable_protocol.c $
// $Rev: 31500 $
// $Date: 2014-12-09 18:30:36 -0600 (Tue, 09 Dec 2014) $

#include "main.h"



//*****************************************************************************
static int _show(s32 set)
{
	char		buf[128];
	int			errs	= 0;
	const char*	ptr;

	gsc_label("Cable Protocol");

	switch (set)
	{
		default:

			errs++;
			ptr	= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case -1:

			ptr	= "This service is not supported by this board.";
			break;

		case SIO4_ASYNC_CABLE_PROTOCOL_RS422_RS485:

			ptr	= "RS-422/RS-485";
			break;

		case SIO4_ASYNC_CABLE_PROTOCOL_RS423:

			ptr	= "RS-423";
			break;

		case SIO4_ASYNC_CABLE_PROTOCOL_RS232:

			ptr	= "RS-232";
			break;

		case SIO4_ASYNC_CABLE_PROTOCOL_RS530:

			ptr	= "RS-530, Mode 1";
			break;

		case SIO4_ASYNC_CABLE_PROTOCOL_RS530A:

			ptr	= "RS-530, Mode 2";
			break;

		case SIO4_ASYNC_CABLE_PROTOCOL_V35:

			ptr	= " V.35, Mode 1";
			break;

		case SIO4_ASYNC_CABLE_PROTOCOL_V35A:

			ptr	= "V.35, Mode 2";
			break;

		case SIO4_ASYNC_CABLE_PROTOCOL_RS422_423_1:

			ptr	= "RS-422/RS-423 Mixed Mode 1";
			break;

		case SIO4_ASYNC_CABLE_PROTOCOL_RS422_423_2:

			ptr	= "RS-422/RS-423 Mixed Mode 2";
			break;

		case SIO4_ASYNC_CABLE_PROTOCOL_DISABLE:

			ptr	= "Disabled";
			break;

		case SIO4_ASYNC_CABLE_PROTOCOL_UNKNOWN:

			ptr	= "Unknown";
			break;
	}

	printf("%s\n", ptr);
	return(errs);
}



//*****************************************************************************
void sio4_async_t_cable_protocol(
	int					fd,
	s32*				arg,
	sio4_async_action_t	action,
	const char**		err)
{
	#define		ERROR	  "async->cable.protocol"
	int			errs	= 0;
	const char*	sts		= NULL;
	s32			tmp;

	switch (action)
	{
		default:

				sts		= ERROR;
				break;

		case SIO4_ASYNC_ACTION_GET:

				arg[0]	= -1;
				errs	= sio4_xcvr_protocol(fd, -1, 0, arg[0], arg);
				break;

		case SIO4_ASYNC_ACTION_INIT:

				errs	= 0;
				arg[0]	= SIO4_ASYNC_CABLE_PROTOCOL_RS232;
				break;

		case SIO4_ASYNC_ACTION_SET:

				tmp		= arg[0];
				errs	= sio4_xcvr_protocol(fd, -1, 0, tmp, NULL);
				break;

		case SIO4_ASYNC_ACTION_SHOW:

				errs	= _show(arg[0]);
				break;

		case SIO4_ASYNC_ACTION_VERIFY:

				switch (arg[0])
				{
					default:					errs	= 1;	break;
					case -1:
					case SIO4_ASYNC_CABLE_PROTOCOL_RS422_RS485:
					case SIO4_ASYNC_CABLE_PROTOCOL_RS423:
					case SIO4_ASYNC_CABLE_PROTOCOL_RS232:
					case SIO4_ASYNC_CABLE_PROTOCOL_RS530:
					case SIO4_ASYNC_CABLE_PROTOCOL_RS530A:
					case SIO4_ASYNC_CABLE_PROTOCOL_V35:
					case SIO4_ASYNC_CABLE_PROTOCOL_V35A:
					case SIO4_ASYNC_CABLE_PROTOCOL_RS422_423_1:
					case SIO4_ASYNC_CABLE_PROTOCOL_RS422_423_2:
					case SIO4_ASYNC_CABLE_PROTOCOL_DISABLE:
					case SIO4_ASYNC_CABLE_PROTOCOL_UNKNOWN:		break;
				}

				break;
	}

	if (errs)
		sts		= ERROR;

	if ((err) && (sts))
		err[0]	= sts;
}


