// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/hdlc/lib/osc_prog.c $
// $Rev: 32776 $
// $Date: 2015-09-07 15:35:07 -0500 (Mon, 07 Sep 2015) $

#include "main.h"



//*****************************************************************************
static int _show(s32 set)
{
	int	errs	= 0;

	gsc_label("Oscillator Program");

	if (set == -1)
	{
		printf("This service is not supported by this board.\n");
	}
	else if (set < 1)
	{
		printf("Invalid value: %ld\n", (long) set);
	}
	else if (set == 1)
	{
		printf("This service is supported by this board.\n");
	}
	else
	{
		gsc_label_long_comma(set);
		printf(" Hz\n");
	}

	return(errs);
}



//*****************************************************************************
void sio4_hdlc_t_osc_prog(
	int					fd,
	s32*				arg,
	sio4_hdlc_action_t	action,
	const char**		err)
{
	#define		ERROR	  "hdlc->osc.prog"
	int			errs	= 0;
	const char*	sts		= NULL;
	s32			tmp;

	switch (action)
	{
		default:

				sts		= ERROR;
				break;

		case SIO4_HDLC_ACTION_GET:

				arg[0]	= -1;
				errs	= sio4_osc_program(fd, -1, 0, arg[0], arg);
				break;

		case SIO4_HDLC_ACTION_INIT:

				errs	= 0;
				arg[0]	= 20000000L;
				break;

		case SIO4_HDLC_ACTION_SET:

				tmp		= arg[0];
				errs	= sio4_osc_program(fd, -1, 0, tmp, NULL);
				break;

		case SIO4_HDLC_ACTION_SHOW:

				errs	= _show(arg[0]);
				break;

		case SIO4_HDLC_ACTION_VERIFY:

				// We do nothing here.
				break;
	}

	if (errs)
		sts		= ERROR;

	if ((err) && (sts))
		err[0]	= sts;
}


